<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <v-row>
      <v-col
        v-for="(item, i) in minicardsSummary"
        :key="i"
        cols="12"
        sm="12"
        md="6"
        lg="6"
      >
        <v-card
          class="mx-auto mt-5"
          elevation="5"
          exact
          outlined
        >
          <v-btn
            elevation="1"
            fab
            tile
            x-large
            dark
            absolute
            top
            left
            :class="item.color"
          >
            <v-icon v-text="item.icon" />
          </v-btn>

          <v-list-item three-line>
            <v-list-item-content class="text-right text--white">
              <div class="overline mb-4">
                {{ item.title }}
              </div>
              <v-list-item-title class="display-1">
                {{ item.total }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>

          <v-divider />

          <v-card-actions class="overline">
            <v-btn
              class="overline primary--text"
              text
              :to="item.to"
            >
              <v-icon class="mr-2 primary--text">
                mdi-arrow-right-circle-outline
              </v-icon>
              visit
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

export default {
  name: 'AdminDashboard',

  data () {
    return {}
  },

  computed: {
    ...mapState('archives', {
      archivesDashboard: 'archivesDashboard'
    }),

    ...mapState('tags', {
      tagsDashboard: 'tagsDashboard'
    }),

    ...mapState('users', {
      usersDashboard: 'usersDashboard'
    }),

    minicardsSummary () {
      return [
        {
          title: 'total archive',
          icon: 'mdi-book-open-page-variant-outline',
          total: this.archivesDashboard.total || 0,
          color: 'amber',
          to: { name: 'Archive' }
        },
        // {
        //   title: 'total tags',
        //   icon: 'mdi-tag-text',
        //   total: this.tagsDashboard.total || 0,
        //   color: 'green',
        //   to: { name: 'Tags' }
        // },
        {
          title: 'total pending students',
          icon: 'mdi-account-group',
          total: this.usersDashboard.total_pending || 0,
          color: 'light-blue',
          to: { name: 'Students', params: { status: 'pending' } }
        }
      ]
    }
  },

  async created () {
    await this.bootstrap()
  },

  methods: {
    ...mapActions('archives', {
      getArchivesDashboard: 'getArchivesDashboard'
    }),

    ...mapActions('tags', {
      getTagsDashboard: 'getTagsDashboard'
    }),

    ...mapActions('users', {
      getUsersDashboard: 'getUsersDashboard'
    }),

    async bootstrap () {
      await this.getArchivesDashboard()
      await this.getTagsDashboard()
      await this.getUsersDashboard()
    }
  }
}
</script>
